/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 * 
 * Copyright (C) 2001-2002 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, A. Lefebvre
 */

package org.objectweb.medor.datasource.api;

/**
 * This class describes a type of a DataStore.
 *
 */
public interface DataStore {

    public static final short MEDORTC_STORE = 0;
    public static final short JDBC_STORE = 1;
    public static final short TEXTFILE_STORE = 2;
    public static final short ODMG_STORE = 3;
    public static final short XMLDOCUMENT_STORE = 4;

	/**
	 * Returns the symbolic name of the DataStore. This name is used to
	 * pass as a parameter the connection to use at evaluation time for
	 * all QueryLeaves attached to this DataStore.
	 */
	public String getName();

	public boolean isSameAs(DataStore ds);

	public boolean isCapable(short operationType);

    public short getDataStoreType();
}
