/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 * 
 * Copyright (C) 2001-2002 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, A. Lefebvre
 */
package org.objectweb.medor.filter.lib;

import org.objectweb.jorm.type.api.PType;
import org.objectweb.jorm.type.api.PTypeSpace;
import org.objectweb.medor.api.TypingException;
import org.objectweb.medor.filter.api.VariableOperand;
import org.objectweb.medor.tuple.api.Tuple;
import org.objectweb.medor.tuple.api.TupleCollection;
import org.objectweb.medor.type.lib.PTypeSpaceMedor;

import java.util.Date;
import java.util.Collection;
import java.sql.Time;
import java.sql.Timestamp;

public class CollectionOperand
	extends BasicOperand {

    public CollectionOperand(Collection c) {
        super(PTypeSpaceMedor.COLLECTION);
		this.type = PTypeSpaceMedor.COLLECTION;

		objectValue = c;
    }

	/**
	 * setValue allows changing the value of the collection.
	 * @param c is the new value of the collection.
	 */
    public void setValue(Collection c) throws TypingException {
		objectValue = c;
	}


    public Object clone() throws CloneNotSupportedException{
        return super.clone();
    }

}
