/**
 * copyright area
 */
package org.objectweb.medor.optim.lib;

import org.objectweb.util.monolog.api.Logger;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.medor.lib.Log;
import org.objectweb.medor.filter.api.Expression;
import org.objectweb.medor.optim.api.RewriteRule;
import org.objectweb.medor.query.api.QueryTree;
import org.objectweb.medor.api.MedorException;

/**
 * @author S.Chassande-Barrioz
 */
public abstract class BasicRule implements RewriteRule {

	public class ModifiedExpression {
		public boolean isModified;
		public Expression e;

		public ModifiedExpression() {
        }

        public ModifiedExpression(Expression ex, boolean ism) {
            e = ex;
            isModified = ism;
        }
	}

	protected Logger log = null;

	protected boolean debug = false;

	public BasicRule() {
		log = Log.loggerFactory.getLogger(
			Log.MEDOR_PREFIX + ".optim.rule");
		debug = log != null && log.isLoggable(BasicLevel.DEBUG);
	}

	public BasicRule(String suffix) {
		log = Log.loggerFactory.getLogger(
			Log.MEDOR_PREFIX + ".optim.rule." + suffix);
		debug = log != null && log.isLoggable(BasicLevel.DEBUG);
	}

	public QueryTree rewrite(QueryTree qt) throws MedorException {
		return null;
	}
}
