/**
 * copyright area
 */
package org.objectweb.medor.optim.jorm.rdb;

import org.objectweb.medor.optim.jorm.TestJormGoUpDecodeRule;
import org.objectweb.medor.optim.jorm.JormLeafRewriter;
import org.objectweb.medor.optim.jorm.RdbJormLeafRewriter;
import org.objectweb.medor.lib.TestMedorHelper;
import org.objectweb.jorm.api.PMapper;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.runtime.MapperJDBC;
import org.objectweb.jorm.runtime.ConnectionSpecJDBC;
import junit.textui.TestRunner;
import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * @author S.Chassande-Barrioz
 */
public class TestRdbJormGoUpDecodeRule extends TestJormGoUpDecodeRule {
    private static String mapperName;
	private static String mappingName;
	private static String miMappingFactory;
	private static String mappingParser;
    private static String pdPath;
	private static String dtdPath;

	static {
		mapperName = System.getProperty(
			"medor.jorm.mapperName", "rdb");
		TestMedorHelper.debug("MapperName = " + mapperName);

		mappingName = System.getProperty(
			"medor.jorm.mappingName", "");
		TestMedorHelper.debug("MappingName = " + mappingName);

		miMappingFactory = System.getProperty(
			"medor.jorm.miMappingName",
			"org.objectweb.jorm.metainfo.lib.rdb.BasicRDBMappingFactory");
		TestMedorHelper.debug("MIMappingFactory = " + miMappingFactory);

		mappingParser = System.getProperty(
			"medor.jorm.miMappingName",
			"org.objectweb.jorm.parser.lib.rdb.RDBParser");
		TestMedorHelper.debug("MappingParser = " + mappingParser);

        pdPath = System.getProperty(
			"medor.jorm.pd.path", "./");
		TestMedorHelper.debug("pd Path = " + pdPath);
		dtdPath = System.getProperty(
			"medor.jorm.dtd.path", "./");
		TestMedorHelper.debug("dtd Path = " + dtdPath);
	}

	/**
	 * main method to launch the tests manually
	 */
	public static void main(String[] args) {
		TestRunner.run(suite());
	}

	/**
	 * This method creates a TestSuite object with the current tests
	 */
	public static Test suite() {
		return new TestSuite(TestRdbJormGoUpDecodeRule.class);
	}

	public TestRdbJormGoUpDecodeRule() {
		super("TestRdbJormGoUpDecodeRule");
	}

	public TestRdbJormGoUpDecodeRule(String n) {
		super(n);
	}

    public String getPDPath() {
        return pdPath;
    }

    public String getDTDPath() {
        return dtdPath;
    }

    public String getMapperName() {
		return mapperName;
	}

	public String getMappingName() {
		return mappingName;
	}

    public PMapper newMappper() {
        PMapper m = new MapperJDBC();
        try {
            ConnectionSpecJDBC cs = new ConnectionSpecJDBC("");
            m.setConnectionFactory(cs);
        }
        catch (PException e) {
            e.printStackTrace();
        }
        return m;
    }

	public String getMIMappingFactory() {
		return miMappingFactory;
	}

	public String getMappingParser() {
		return mappingParser;
	}

	public JormLeafRewriter createJormLeafRewriter() {
		return new RdbJormLeafRewriter();
	}

}
